diff --git a/arch/powerpc/dts/qoriq-fman3-1-10g-0.dtsi b/arch/powerpc/dts/qoriq-fman3-1-10g-0.dtsi
index 889c8d450e09..65bb8a4b0b63 100644
--- a/arch/powerpc/dts/qoriq-fman3-1-10g-0.dtsi
+++ b/arch/powerpc/dts/qoriq-fman3-1-10g-0.dtsi
@@ -30,7 +30,7 @@ fman@500000 {
 		pcsphy-handle = <&pcsphy14>;
 	};
 
-	mdio@f1000 {
+	mdio@5f1000 {
 		#address-cells = <1>;
 		#size-cells = <0>;
 		compatible = "fsl,fman-memac-mdio", "fsl,fman-xmdio";
diff --git a/arch/powerpc/dts/qoriq-fman3-1-10g-1.dtsi b/arch/powerpc/dts/qoriq-fman3-1-10g-1.dtsi
index 2e456983372c..eb39d29b39fa 100644
--- a/arch/powerpc/dts/qoriq-fman3-1-10g-1.dtsi
+++ b/arch/powerpc/dts/qoriq-fman3-1-10g-1.dtsi
@@ -30,7 +30,7 @@ fman@500000 {
 		pcsphy-handle = <&pcsphy15>;
 	};
 
-	mdio@f3000 {
+	mdio@5f3000 {
 		#address-cells = <1>;
 		#size-cells = <0>;
 		compatible = "fsl,fman-memac-mdio", "fsl,fman-xmdio";
diff --git a/arch/powerpc/dts/qoriq-fman3-1-1g-0.dtsi b/arch/powerpc/dts/qoriq-fman3-1-1g-0.dtsi
index b4ff19bf495a..2f2209dbc9bb 100644
--- a/arch/powerpc/dts/qoriq-fman3-1-1g-0.dtsi
+++ b/arch/powerpc/dts/qoriq-fman3-1-1g-0.dtsi
@@ -29,7 +29,7 @@ fman@500000 {
 		pcsphy-handle = <&pcsphy8>;
 	};
 
-	mdio@e1000 {
+	mdio@5e1000 {
 		#address-cells = <1>;
 		#size-cells = <0>;
 		compatible = "fsl,fman-memac-mdio", "fsl,fman-xmdio";
diff --git a/arch/powerpc/dts/qoriq-fman3-1-1g-1.dtsi b/arch/powerpc/dts/qoriq-fman3-1-1g-1.dtsi
index 239c56ad1f62..11653c58b5f0 100644
--- a/arch/powerpc/dts/qoriq-fman3-1-1g-1.dtsi
+++ b/arch/powerpc/dts/qoriq-fman3-1-1g-1.dtsi
@@ -29,7 +29,7 @@ fman@500000 {
 		pcsphy-handle = <&pcsphy9>;
 	};
 
-	mdio@e3000 {
+	mdio@5e3000 {
 		#address-cells = <1>;
 		#size-cells = <0>;
 		compatible = "fsl,fman-memac-mdio", "fsl,fman-xmdio";
diff --git a/arch/powerpc/dts/qoriq-fman3-1-1g-2.dtsi b/arch/powerpc/dts/qoriq-fman3-1-1g-2.dtsi
index 6e2bb009d9aa..ae27c7bc6df2 100644
--- a/arch/powerpc/dts/qoriq-fman3-1-1g-2.dtsi
+++ b/arch/powerpc/dts/qoriq-fman3-1-1g-2.dtsi
@@ -29,7 +29,7 @@ fman@500000 {
 		pcsphy-handle = <&pcsphy10>;
 	};
 
-	mdio@e5000 {
+	mdio@5e5000 {
 		#address-cells = <1>;
 		#size-cells = <0>;
 		compatible = "fsl,fman-memac-mdio", "fsl,fman-xmdio";
diff --git a/arch/powerpc/dts/qoriq-fman3-1-1g-3.dtsi b/arch/powerpc/dts/qoriq-fman3-1-1g-3.dtsi
index 29dd94ba7498..55ae5499176e 100644
--- a/arch/powerpc/dts/qoriq-fman3-1-1g-3.dtsi
+++ b/arch/powerpc/dts/qoriq-fman3-1-1g-3.dtsi
@@ -29,7 +29,7 @@ fman@500000 {
 		pcsphy-handle = <&pcsphy11>;
 	};
 
-	mdio@e7000 {
+	mdio@5e7000 {
 		#address-cells = <1>;
 		#size-cells = <0>;
 		compatible = "fsl,fman-memac-mdio", "fsl,fman-xmdio";
diff --git a/arch/powerpc/dts/qoriq-fman3-1-1g-4.dtsi b/arch/powerpc/dts/qoriq-fman3-1-1g-4.dtsi
index a5b493582703..833cf3e23d8e 100644
--- a/arch/powerpc/dts/qoriq-fman3-1-1g-4.dtsi
+++ b/arch/powerpc/dts/qoriq-fman3-1-1g-4.dtsi
@@ -29,7 +29,7 @@ fman@500000 {
 		pcsphy-handle = <&pcsphy12>;
 	};
 
-	mdio@e9000 {
+	mdio@5e9000 {
 		#address-cells = <1>;
 		#size-cells = <0>;
 		compatible = "fsl,fman-memac-mdio", "fsl,fman-xmdio";
diff --git a/arch/powerpc/dts/qoriq-fman3-1-1g-5.dtsi b/arch/powerpc/dts/qoriq-fman3-1-1g-5.dtsi
index 486c84bf9810..81da55dfbe26 100644
--- a/arch/powerpc/dts/qoriq-fman3-1-1g-5.dtsi
+++ b/arch/powerpc/dts/qoriq-fman3-1-1g-5.dtsi
@@ -29,7 +29,7 @@ fman@500000 {
 		pcsphy-handle = <&pcsphy13>;
 	};
 
-	mdio@eb000 {
+	mdio@5eb000 {
 		#address-cells = <1>;
 		#size-cells = <0>;
 		compatible = "fsl,fman-memac-mdio", "fsl,fman-xmdio";
diff --git a/arch/powerpc/dts/qoriq-fman3-1.dtsi b/arch/powerpc/dts/qoriq-fman3-1.dtsi
index d8609c3ecfdb..9efcf26c4abc 100644
--- a/arch/powerpc/dts/qoriq-fman3-1.dtsi
+++ b/arch/powerpc/dts/qoriq-fman3-1.dtsi
@@ -61,14 +61,14 @@ fman1: fman@500000 {
 		reg = <0x87000 0x1000>;
 	};
 
-	mdio1: mdio@fc000 {
+	mdio1: mdio@5fc000 {
 		#address-cells = <1>;
 		#size-cells = <0>;
 		compatible = "fsl,fman-memac-mdio", "fsl,fman-xmdio";
 		reg = <0xfc000 0x1000>;
 	};
 
-	mdio@fd000 {
+	mdio@5fd000 {
 		#address-cells = <1>;
 		#size-cells = <0>;
 		compatible = "fsl,fman-memac-mdio", "fsl,fman-xmdio";
diff --git a/arch/powerpc/dts/t4240rdb.dts b/arch/powerpc/dts/t4240rdb.dts
index 6d31675c5ead..b3251e330de9 100644
--- a/arch/powerpc/dts/t4240rdb.dts
+++ b/arch/powerpc/dts/t4240rdb.dts
@@ -100,7 +100,7 @@
 			phy-connection-type = "xgmii";
 		};
 
-		mdio@fc000 {
+		mdio@5fc000 {
 			sgmiiphy21: ethernet-phy@0 {
 				reg = <0x0>;
 			};
@@ -134,7 +134,7 @@
 			};
 		};
 
-		mdio@fd000 {
+		mdio@5fd000 {
 			xfiphy1: ethernet-phy@10 {
 				compatible = "ethernet-phy-id13e5.1002";
 				reg = <0x10>;
diff --git a/arch/powerpc/dts/t4240si-post.dtsi b/arch/powerpc/dts/t4240si-post.dtsi
index f614d19965d3..a596f48b54fe 100644
--- a/arch/powerpc/dts/t4240si-post.dtsi
+++ b/arch/powerpc/dts/t4240si-post.dtsi
@@ -90,11 +90,11 @@
 		enet15: ethernet@f2000 {
 		};
 
-		mdio@fc000 {
+		mdio@5fc000 {
 			interrupts = <100 1 0 0>;
 		};
 
-		mdio@fd000 {
+		mdio@5fd000 {
 			interrupts = <101 1 0 0>;
 		};
 	};